//==============================================
// кластеризация двумерной таблицы по степени риска
//==============================================

#ifndef CLUSTER_H
#define CLUSTER_H

#include <list>
using namespace std;

class Spreadsheet;
struct selcel;

// элемент кластера
struct fUnit{
   int ind;     // начальный ( ) индекс в списке
   int r1;      // значение в выборке 1
   int r2;      // значение в выборке 2
   double chi2; // расст.между текущим и следующим (кроме последнего)элементом
   double lamb; // лямбда
};

class claster{

public:
// все вычисления делать в конструкторе
   claster(Spreadsheet *sp, selcel *sc, int &err, QString &sres);
   ~claster();// деструктор

private:
   void outOdds(int numClusters);   // вывод отношения шансов
    void OddsRatio(int numClusters); // расчет и вывод отношения шансов
    void setRes(int numClusters);// вывод результатов в окно Result
   double lnLambda(int r1, int r2);
   double chi2dist(list<fUnit>::iterator it);
   // вывод результатов в окно вывода
   void outres(int istep, int iclus);
    // вывод результатов в электронную таблицу
   void outresSheet(int istep, int iclus);
   // вычисление значимости набора кластеров
   double znach(int numclus);
   int merge(int numclus);
   int copyFactor();// цикл объединения факторов
   void sortClaster();// сортировка

// Переменные ------------------
   int sum1;// сумма выборки 1
   int sum2;// сумма выборки 2
   QString tblres;  // результат в формате таблицы HTML
   QList<QString> factName; // имена факторов
   int NumFactors;// кол-во факторов
   double log0; // логарифм N+M
   int col0;   // сдвиг левого столбца вправо
   // список кластеров, число которых последовательно уменьшается на 1
   list<fUnit> cls;
// квадратная таблица номер кластера(от 1) от номера шага алгоритма
// в последней строке номера (от 1) отсортированных факторов
   int *clsInd;// размерность = NumFactors X NumFactors
   double *pval;    // значимость набора кластеров
   fUnit *pUnit1;   // 0 в выборке контроль; Содержит отсортированные факторы
   fUnit *pUnit2;   // нулей нет, номера кластеров от 0; Принадлежность кластерам (от 0)
   fUnit *pUnit3;   // 0 в выборке случай; Не используется
   int fnum1;   // размер массива pUnit1
   int fnum2;   // размер массива pUnit2
   int fnum3;   // размер массива pUnit3

   int *R1;    // упорядочение факторов по частоте
   int *R2;    // упорядочение факторов по частоте
   Spreadsheet *spreadsheet;  // таблица
   selcel *scell; // координаты выделенной области
};

#endif // CLUSTER_H
