//====================================================
// точный тест Фишера
// Computes the shortest path length for table
// with fixed marginals Ri, Cj
//====================================================

#ifndef FEXACT_H
#define FEXACT_H

#define MAX(X,Y) ((X)>(Y) ? (X) : (Y))
#define MIN(X,Y) ((X)<(Y) ? (X) : (Y))
#define MAXNUMCOL 100 // максимальное число столбцов

class fexact{
public:
   fexact( int nrow, int ncol, double *fact);
   ~fexact();
// вычисление кратчайшего пути для таблицы сопряженности
   double getSP(int nrow, int *irow, int ncol, int *icol);

private:
   // указатели для массивов
   int i41, i42, i43, i44, i45, i46, i47, i40;
   double tol;    // малое число
   double *lnFac; // внешняя ссылка на логарифм факториалов
   int *iwk;      // рабочий массив
   double *Ystk;  // рабочий массив
   int row[2];   // сумма строк
// сумма столбцов в порядке возрастания
   int *col;
//   int col[MAXNUMCOL];

// функции ------------
   void f11act(int *irow, int i1, int i2, int *new1);
   void f8xact(int *irow, int is, int i1, int izero, int *new1);
   double f4xact(int nrow, int *irow, int ncol, int *icol, double dspt,
      double *fact, int *icstk, int *ncstk, int *lstk, int *mstk,
      int *nstk, int *nrstk, int *irstk, double *ystk,
      const double *tol);
};

#endif
