#include <math.h>
#include <QDebug>
#include "longpath.h"
//________________________________
// класс вычисления наибольшей длины вектора
// err - код ошибки
// размещение массивов в динамической памяти
longpath::longpath(int &err, int maxSumTbl, double *fact){
   sumTbl = maxSumTbl;
   err = 0;// успех
   R1 = 0;
   numCol = 0;
   W = new double[maxSumTbl];
   if(!W){ err=2; return;}
   lnFact = fact;
//   lnFact = new double[maxSumTbl+1];// lnFact[]=ln(x!)
//   if(!lnFact){ err=3; return;}
//   lnfact(maxSumTbl);// вычисление факториалов
   
}
//_________________________________
// деструктор
longpath::~longpath(){
   delete [] W;
//   delete [] lnFact;
}
//_________________________________
// ВЫХОД
//   xMode - мода (вектор максимальной длины = П(Сi, xi*)
// ВХОД
//   Row - сумма 1-ой строки
//   numColumn - число столбцов
//   Column - сумма столбцов
int longpath::getMode(int numColumn, int Row, int *Column,
   int *xMode){
   if(numColumn<1 || numColumn > MAXNUMCOL) return 1;// ошибка
   numCol = numColumn;
   if(Row<0) return 4;
   R1 = Row;   // сумма 1-ой строки
   Clmn = Column;
   N = 0;
   for(int i=0; i<numCol; i++){
     N += Clmn[i];
   }
   if(N > sumTbl) return 2;// ошибка
   if(N < R1) return 3;// ошибка
   if(numColumn==1){
      xMode[0] = R1;
      return 0; // успех
   }
   Z = xMode;
   deltaZv = getDeltaZ();// вычислить нач.значения z[]
//   if(deltaZv==0) return 0;
   int lamb = 1;
   if(deltaZv>0){
      lamb = -1;
   }
//   qDebug()<<" deltaZv="<<deltaZv;
   init = 0;
   for(int i=0; i<abs(deltaZv); i++){
      int j = getJ();
      Z[j] += lamb;
   }
   return 0; // успех
}
//_________________________________
// индекс для минимума W[]
int longpath::getJ(){
   if(init==0){// делать один раз при входе в цикл
      init = 1;
      for(int i=0; i<numCol; i++){
         if(deltaZv>0){
            W[i] = -Z[i]/(Clmn[i]+1.);
         }else{
            W[i] = (Z[i]+1.)/(Clmn[i]+1.);
         }
//         qDebug()<<" i="<<i<<" W[i]="<<W[i];
      }
   }
   int jMin = 0;
   double wMin = W[jMin];
   for(int i=1; i<numCol; i++){
      if(W[i] < wMin){
         jMin = i;
         wMin = W[jMin];
      }
   }
   if(deltaZv>0){
      W[jMin] = -(Z[jMin]-1.)/(Clmn[jMin]+1.);
   }else{
      W[jMin] = (Z[jMin]+2.)/(Clmn[jMin]+1.);
   }
//   qDebug()<<" jMin="<<jMin<<" W[jMin] ="<<W[jMin];
   return jMin;
}
//_________________________________
// вычислить начальное значение delta* и Z*
int longpath::getDeltaZ(){
   // проверка единственности Z*
   int init1 = 0;
   int Q = 0;  // кол-во совпадающих мод z
   int s = 0;
   for(int i=0; i<numCol; i++){
      int ost = ((R1+1)*(Clmn[i]+1))%(N+2);
      int zMax = ((R1+1)*(Clmn[i]+1))/(N+2);
      double R1z;
      int delta1, delta2;
      if(ost==0){
         if(init1==0){
            init1 = 1;
            R1z = ((R1+1.)*(numCol-2.))/(N+2.)+1;
            delta1 = MAX(-R1, R1z-numCol);
            delta2 = MIN(N-R1, R1z);
//            qDebug()<<" delta1="<<delta1<<" delta2="<<delta2
//            <<" R1z="<<R1z<<" R1="<<R1<<" N="<<N
//            <<" numCol"<<numCol;
         }
         if(delta1>0){
            Z[i] = zMax-1;
         }else if(delta2<0){
            Z[i] = zMax;
         }else{
            if(Q<delta2){
               Z[i] = zMax-1;
            }else{
               Z[i] = zMax;
            }
         }
         Q++;
      }else{
         Z[i] = zMax;
      }
      s += Z[i];
//      qDebug()<<" i="<<i<<" Z[i]="<<Z[i];
   }
   int deltat = s - R1;
//   qDebug()<<" deltat="<<deltat<<" Q="<<Q<<" s="<<s
//          <<" R1="<<R1;
   return deltat;
}
//______________________________
// заполнить массив lnFact (ln факториала)
//int longpath::lnfact(int maxFact){
//   double logFac = 0;
//   lnFact[0] = 0;
//   for(int i=1; i<=maxFact; i++){
//      logFac += log(i);
//      lnFact[i] = logFac;
////      qDebug()<<" i="<<i<<" lnFact[i]="<<lnFact[i];
//   }
//   return 0;
//}
//______________________________
// натуральный логарифм биномиального коэффициента (m, n)
double longpath::ln_C(int m, int n){
//   double ln;
   double lnC = lnFact[m] - lnFact[n] - lnFact[m-n];
//   unsigned long expln = exp(ln) + 0.5;
//   qDebug()<<" m="<<m<<" n="<<n<<" binCoeff="<<expln;

   return lnC;
}
