// класс главное окно
// Сюда добавлять новые функции
//=============================

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

class QScrollArea;
class QAction;
class QLabel;
class QPushButton;
class QProgressBar;
class FindDialog;
class Spreadsheet;
class SelDialog;

class MainWindow : public QMainWindow
{
   Q_OBJECT

public:
   MainWindow();

protected:
   void closeEvent(QCloseEvent *event);

private:
   // функции ------------------------------
   void gInteraction(); // взаимодейсвие генов
   void hardyWcalc();   // вычисления Харди-Вайнберга
   void clusterCalc();  // вычисления кластеризации
   void chi2();         // вычисления хи-квадрат
   void fisher();       // вычисления точный Фишер
   int autoRecalcOff(int yes = 0);
   void startCalc(int progBarUp);// показать индикатор прогресса
   void outResult(QString &str, int err);// вывести результаты
   void SelectCells();//
   void showDock();
   void createDockWindows();
   void createActions();
   void createMenus();
   void createContextMenu();
   void createToolBars();
   void createStatusBar();
   void readSettings();
   void writeSettings();
   bool okToContinue();
   bool loadFile(const QString &fileName);
   bool saveFile(const QString &fileName);
   void setCurrentFile(const QString &fileName);
   void updateRecentFileActions();
   QString strippedName(const QString &fullFileName);
    // переменные
   QTimer *timerCalc;
   SelDialog *pSelDlg;
   QDockWidget *dock;

   QScrollArea *saResult;
   QLabel *lbResult;

   QLabel *lbIndent;
   QPushButton *btnStop;
   QProgressBar *pbCalc;

   Spreadsheet *spreadsheet;
   FindDialog *findDialog;
   QLabel *locationLabel;
   QLabel *formulaLabel;
   QStringList recentFiles;
   QString curFile;

   enum { MaxRecentFiles = 5 };
   QAction *recentFileActions[MaxRecentFiles];
   QAction *separatorAction;

   QMenu *fileMenu;
   QMenu *editMenu;
   QMenu *selectSubMenu;
   QMenu *toolsMenu;
   QMenu *optionsMenu;
   QMenu *helpMenu;
   QToolBar *fileToolBar;
   QToolBar *editToolBar;
   // Добавить пункт меню
   QAction *gInter;     // взаимодействие
   QAction *hardyW;     // харди-вайнберг
   QAction *cluster;    // кластер
   QAction *statChi2;   // хи-квадрат
   QAction *statFisher; // фишер
   QAction *showResult; //
   QAction *newAction;
   QAction *openAction;
   QAction *saveAction;
   QAction *saveAsAction;
   QAction *exitAction;
   QAction *cutAction;
   QAction *copyAction;
   QAction *pasteAction;
   QAction *deleteAction;
   QAction *selectRowAction;
   QAction *selectColumnAction;
   QAction *selectAllAction;
   QAction *findAction;
   QAction *goToCellAction;
   QAction *recalculateAction;
   QAction *sortAction;
   QAction *showGridAction;
   QAction *autoRecalcAction;
   QAction *aboutAction;


private slots:
    // Добавить слоты
   void slotMenuGeneInter();
   void slotMenuHardyW();
   void slotMenuCluster();
   void slotMenuChi2();
   void slotMenuFisher();

   void slotProgress();
   void slotStopCalc();
   void slotCalc();     // начать вычисления

   void newFile();
   void open();
   bool save();
   bool saveAs();
   void find();
   void goToCell();
   void sort();
   void about();
   void openRecentFile();
   void updateStatusBar();
   void spreadsheetModified();

signals:
   void signalTestRange();
};

#endif
