#include <QtGui>

#include "seldialog.h"
#include "spreadsheet.h"
#include "longpath.h"
//________________________________________________
// окно диалога выделения ячеек в таблице
// вызывается один раз, поэтому нет деструктора
SelDialog::SelDialog(Spreadsheet *pSp, QWidget *parent)
    : QDialog(parent){
//   MAXROWCOUNT = RowCount;
   minCol = 2;
   R1 = new int[RowCount];
   R2 = new int[RowCount];
   xVector = new int[RowCount];
   colSum = new int[RowCount];
   scell.R1 = R1;
   scell.R2 = R2;
   scell.rowSum = xVector;
   scell.colSum = colSum;
   numCol = 0;
   connect(parent, SIGNAL(signalTestRange()),
      this, SLOT(slotTestRange()));
   pSheet = pSp;
   connect(pSheet, SIGNAL(itemSelectionChanged()),
      this, SLOT(slotTestRange()));

   Range = new QLineEdit(this);
   Range->setEnabled(false);
   QLabel *lbRange = new QLabel(tr("Cells &Range"));
   lbRange->setBuddy(Range);

   testInput = new QLabel(this);
   testInput->setStyleSheet(QString(
         "QLabel { background-color: white }"));
   QLabel *seLabel = new QLabel(tr("Test Selection"));
//   seLabel->setBuddy(testInput);
//   seLabel->setStyleSheet(QString(
//     "QLabel { background-color: white }"));

   pOk = new QPushButton(tr("&OK"));

   QPushButton *pCancel = new QPushButton(tr("&Cancel"));

   connect(pOk, SIGNAL(clicked()), SLOT(accept()));
   connect(pCancel, SIGNAL(clicked()), SLOT(reject()));

// надпись на форме
   textSelect
   <<tr("<b>Select 2xN Cells with Numbers</b>") // фишер
   <<tr("<b>Select MxN Cells with Numbers</b>") // хи-квадрат
   <<tr("<b>Select 2xN Cells with Numbers</b>") // кластер
   <<tr("<b>Select NxN Cells with Numbers</b>") // харди
   <<tr("<b>Select Nx2M Cells with Numbers</b>") // взаимодействие генов
     ;
   //=====================
   spf = new QSpinBox(this);
   spf->setRange(0,9);
   connect(spf, SIGNAL(valueChanged(int)),
           this, SLOT(slotSpinText(int)));
   sbl = new QLabel(this);
   sbw = new QWidget(this);
   QLabel *lbsb = new QLabel("Accuracy=");
   QHBoxLayout *sblt = new QHBoxLayout();
   sblt->addWidget(lbsb);
   sblt->addWidget(spf);
   sbw->setLayout(sblt);

//   sbl = new QLabel("Number of digits");
//===================
   chk2x2 = new QCheckBox(tr("Yates correction"));
   connect(chk2x2, SIGNAL(stateChanged(int)),
           SLOT(slotTestRange()));
   chk2x2->setHidden(true);
   lMes = new QLabel(this);
//   lMes->setAlignment(Qt::AlignHCenter);

   QGridLayout *pTop = new QGridLayout(this);
   int row=0;

   pTop->addWidget(lMes, row++, 0, 1, 2);
   pTop->addWidget(sbl, row, 0, 0);
//   pTop->addWidget(spf, row++, 1, 0);
   pTop->addWidget(sbw, row++, 1, 0);
   pTop->addWidget(chk2x2, row++, 0, 0);
   pTop->addWidget(lbRange, row, 0);
   pTop->addWidget(Range, row++, 1);
   pTop->addWidget(seLabel, row, 0);
   pTop->addWidget(testInput, row++, 1);
   pTop->addWidget(pOk, row, 0);
   pTop->addWidget(pCancel, row++, 1);
   setLayout(pTop);
// заголовок окна в зависимости от теста
   nameWin
    <<tr("Fisher 2xN test")
    <<tr("Chi-squared test")
    <<tr("Risk cluster")
    <<tr("Exact Hardy-Weinberg")
    <<tr("Gene interaction")
    ;
   setFixedHeight(sizeHint().height());
   setModal(false);
//   pOk->setFocus();
   numTest = -1;
}
//_____________________________
// проверка выделенных ячеек
// вызывается при изменении выделения
void SelDialog::slotTestRange(){
   if(numTest<0) return;
   lMes->setText(textSelect.at(numTest));
   setWindowTitle(nameWin.at(numTest));
   QTableWidgetSelectionRange range = pSheet->selectedRange();
   cols = range.columnCount();// кол-во столбцов
   rows = range.rowCount();   // кол-во строк
   int botrow = range.bottomRow() + 1;
   int rightcol = range.rightColumn();
   leftcol = rightcol - cols + 1;
   toprow = botrow - rows;
   scell.cols = cols;
   scell.rows = rows;
   scell.leftcol = leftcol;
   scell.toprow = toprow;

   QChar ch1 = 'A' + leftcol;
   QChar ch2 = 'A' + rightcol;
   QString str = tr("%1%2:%3%4").arg(ch1).arg(toprow+1)
      .arg(ch2).arg(botrow);
   Range->setText(str);

   if(numTest==Fisher &&
         ((cols==minCol && rows>=minCol && rows<=MAXFISHER)
         || (rows==minCol && cols>=minCol && cols<=MAXFISHER))){
      pOk->setEnabled(testFisher());
      numCol = (rows>cols) ? rows : cols ;
      return;
   }else if(numTest==Chi2 && (cols>=minCol && rows>=minCol)){
      pOk->setEnabled(testChi2());
      return;
   }else if(numTest==CLUSTER && (leftcol>0 && (cols>minCol && rows==minCol)
    || (cols==2 && rows>2))){
      pOk->setEnabled(testCluster());
      return;
   }else if(numTest==HARDYW && cols>=2 && cols==rows){
      numCol = cols;
      pOk->setEnabled(testHardyW());
      return;
//   }else if(numTest==GINTER && cols==2 && rows==4){
   }else if(numTest==GINTER && cols>=2 && rows>=4
            && rows%2==0){
      numCol = cols;
      pOk->setEnabled(testInter());
      return;
   }
   // размеры таблицы или numTest некорректны
   str = tr("<font color=\"red\"> wrong Range</font>");
   testInput->setText(str);
   pOk->setEnabled(false);
   chk2x2->setChecked(false);
   chk2x2->setEnabled(false);
}
//_______________________________________________
// проверка выделения ячеек теста Харди-Вайнберга
bool SelDialog::testHardyW(){
   QString str;
   int k=0;
   for(int i=0; i<rows; i++){
      for(int j=0; j<cols; j++){
         k = i*cols + j;
         QTableWidgetItem *item =
               pSheet->item(i+toprow, j+leftcol);
         int dec;
         if(j>=i){
            if(item == 0){
               str = tr("<font color=\"red\">Empty cell</font>");
               testInput->setText(str);
               return false;
            }
            QString val = item->text();
            bool ok;
            dec = val.toInt(&ok, 10);
            if(!ok || dec<0){
               str = tr("<font color=\"red\">Bad number</font>");
               testInput->setText(str);
               return false;
            }
         }else{
            if(item != 0){
               str = tr("<font color=\"red\">Left botton nonempty cell</font>");
               testInput->setText(str);
               return false;
            }
            dec=0;
         }
         R1[k] = dec;
         qDebug()<<" value="<<dec;
         if(j==0){
            colSum[i] = dec;// сумма строки
         }else{// j>=0
            colSum[i] += dec;
         }
         if(i==0){
            xVector[j] = dec;
         }else{// i>=0
            xVector[j] += dec;
         }
      }// j
   }// i
   for(int i=0; i<rows; i++){
      if(colSum[i]==0 && xVector[i]==0){
         str = tr("<font color=\"red\">Null Genotype number=%1</font>"
                  ).arg(i+1);
         testInput->setText(str);
         return false; // сумма сроки
      }
   }
   str = tr("<font color=\"green\"> All is good</font>");
   testInput->setText(str);
   return true;
}
//_______________________________________________
// Взаимодействие генов
// проверка суммы строк, столбцов, гаплотипов
//    R1 - матрица 1-ой выборки (по строкам)
//    R2 - матрица 2-ой выборки (по строкам)
bool SelDialog::testInter(){
    // проверка суммы столбцов
    for(int j=0; j<cols; j++){
       // 1-ая выборка
       bool ok = testInter_Cols(j, j+1, 0 , rows/2);
       if(!ok) return false;
       // 2-ая выборка
       ok = testInter_Cols(j, j+1, rows/2 , rows);
       if(!ok) return false;
    }// j
    // проверка суммы строк обеих выборок
    for(int i=0; i<rows; i++){
       bool ok = testInter_Cols(0, cols, i , i+1);
       if(!ok) return false;
    }// i
    // проверка суммы гаплотипов
    for(int i=0; i<rows/2; i++){
       for(int j=0; j<cols; j++){
          int k = i*cols+j;
          int t = R1[k] + R2[k];
          if(t<=0){
             str = tr("<font color=\"red\">Gaplotype=0 for i=%1, j=%2</font>").arg(i).arg(j);
             testInput->setText(str);
             return false;
          }
       }
    }// i
    str = tr("<font color=\"green\"> All is good</font>");
    testInput->setText(str);
    return true;
}
//___________________________
// тестирование столбцов
bool SelDialog::testInter_Cols(int j1, int j2, int r1, int r2){
   int c1 = 0;  // сумма столбца
   for(int j=j1; j<j2; j++){
      for(int i=r1; i<r2; i++){
         QTableWidgetItem *item = pSheet->item(i+toprow, j+leftcol);
         if(item==0){
            str = tr("<font color=\"red\">Empty cell</font>");
            testInput->setText(str);
            return false;
         }
         QString val = item->text();
         bool ok;
         int dec = val.toInt(&ok, 10);
         if(!ok || dec<0){
            str = tr("<font color=\"red\">Bad number</font>");
            testInput->setText(str);
            return false;
         }
         qDebug()<<" value="<<dec;
         c1 += dec;
         int k = i*cols+j;
         if(k < cols*rows/2){
            R1[k] = dec;
         }else{
            R2[k-cols*rows/2] = dec;
         }
      }// i
   }// j
   bool ok;
   if(c1>0){
      ok = true;
   }else{
      ok = false;
      str = tr("<font color=\"red\">Column or row Sum=0</font>");
      testInput->setText(str);
   }
   return ok;
}
//_______________________________________________
// проверка ячеек теста Фишера
// заполнение величин 1-ой строки и суммы столбцов
bool SelDialog::testFisher(){
   QString str;
   total=0;
   for(int j=0; j<cols; j++){
      for(int i=0; i<rows; i++){
         QTableWidgetItem *item =
//               pSheet->item(i+toprow-1, j+leftcol);
               pSheet->item(i+toprow, j+leftcol);
         if(item==0){
            str = tr("<font color=\"red\">Empty cell</font>");
            testInput->setText(str);
            return false;
         }
         QString val = item->text();
         bool ok;
         int dec = val.toInt(&ok, 10);
         if(!ok || dec<0){
            str = tr("<font color=\"red\">Bad number</font>");
            testInput->setText(str);
            return false;
         }
         qDebug()<<" value="<<dec;
         total += dec;
//         if(cols==2){
         if(cols<=rows){// вертикальное расположение таблицы
            if(j==0){
               xVector[i] = dec;
               colSum[i] = dec;
            }else{// j==1
               colSum[i] += dec;
               if(colSum[i]==0) return false;
            }
         }else{// rows<cols - горизонт.расположение
            if(i==0){
               xVector[j] = dec;
               colSum[j] = dec;
            }else{// i==1
               colSum[j] += dec;
               if(colSum[j]==0) return false;
            }
         }
      }// i
   }// j
   str = tr("<font color=\"green\"> All is good</font>");
   testInput->setText(str);
   return true;
}
//_______________________________________________
// проверка ячеек теста Хи-квадрат
// ВХОД: toprow - первая строка, leftcol - первый столбец
//   rows - кол-во строк, cols - кол-во столбцов
// ВЫХОД: total - хи-квадрат
//   numCol - число степеней свободы
bool SelDialog::testChi2(){
   if(cols==2 && rows==2){
      chk2x2->setEnabled(true);
   }else{
      chk2x2->setChecked(false);
      chk2x2->setEnabled(false);
   }

   QString str;
   total = 0;
// вычисление суммы строк
   for(int i=0; i<rows; i++){
      xVector[i]=0;// сумма строки
      for(int j=0; j<cols; j++){
         if(i==0) colSum[j]=0;
         QTableWidgetItem *item =
//         pSheet->item(i+toprow-1, j+leftcol);
         pSheet->item(i+toprow, j+leftcol);
         if(item==0){
            str = tr("<font color=\"red\">Empty cell</font>");
            testInput->setText(str);
            return false;
         }
         QString val = item->text();
         bool ok;
         int dec = val.toInt(&ok, 10);
         if(!ok || dec<0){
            str = tr("<font color=\"red\">Wrong number</font>");
            testInput->setText(str);
            return false;
         }
         xVector[i] += dec;
         colSum[j] += dec;
         qDebug()<<" value="<<dec;
         total += dec;
      }// j
      if(xVector[i]==0){
         str = tr("<font color=\"red\">Sum=0"
//         " for row # %1</font>").arg(i+toprow);
         " for row # %1</font>").arg(i+toprow+1);
         testInput->setText(str);
         return false;
      }
   }// i
   double Yates = 0;// Yates correction
   if(chk2x2->isChecked()){
      Yates = 0.5;
   }
// вычисление суммы хи-квадрат ===============
   chi2sum = 0;
   for(int i=0; i<rows; i++){
      for(int j=0; j<cols; j++){
         if(colSum[j]==0){
            str = tr("<font color=\"red\">Sum=0 for"
            " column # %1</font>").arg(j+leftcol+1);
            testInput->setText(str);
            return false;
         }
         QTableWidgetItem *item =
//         pSheet->item(i+toprow-1, j+leftcol);
         pSheet->item(i+toprow, j+leftcol);
         QString val = item->text();
         bool ok;
         int dec = val.toInt(&ok, 10);
         // ожидаемая = E
         double tO = ((double) colSum[j]*xVector[i])/total;
         // наблюдаемая = O
         double tN = fabs(dec-tO)-Yates; // (O-E)
         chi2sum += tN*tN/tO; // (O-E)^2/E
      }// j
   }// i
   numCol = (rows-1)*(cols-1);
   str = tr("<font color=\"green\"> All is good</font>");
   testInput->setText(str);
   return true;
}
//__________________________________
// проверка области выделения КЛАСТЕ�
// ВХОД: toprow - верхняя строка, leftcol - левый столбец
//   rows - кол-во строк, cols - кол-во столбцов
// ВЫХОД:
//   numCol=cols - кол-во столбцов
bool SelDialog::testCluster(){
    QString str;
    scell.factNames.clear();
    scell.sampNames.clear();
    if(rows==2){// горизонтальная таблица
        // проверка чисел
        for(int i=0; i<rows; i++){// rows=2
        // проверка названия выборок
            int jn = leftcol-1;
            if(jn<0){
                str = tr("<font color=\"red\">Samples has not names</font>");
                testInput->setText(str);
                return false;
            }
            QTableWidgetItem *item = pSheet->item(i+toprow, jn);
            if(item==0){
                str = tr("<font color=\"red\">Samples name is empty</font>");
                testInput->setText(str);
                return false;
            }else{
                scell.sampNames.append(item->text());
            }
        //////////////////
            xVector[i]=0;// сумма строки
            for(int j=0; j<cols; j++){// по столбцам cols>2
                if(i==0) colSum[j]=0;
                QTableWidgetItem *item =
                        pSheet->item(i+toprow, j+leftcol);
                if(item==0){
                    str = tr("<font color=\"red\">Empty cell</font>");
                    testInput->setText(str);
                    return false;
                }
                QString val = item->text();
                bool ok;
                int dec = val.toInt(&ok, 10);
                if(!ok || dec<0){
                    str = tr("<font color=\"red\">Wrong number</font>");
                    testInput->setText(str);
                    return false;
                }
                if(i==0){
                    R1[j] = dec;
                }else{
                    R2[j] = dec;
                }
                xVector[i] += dec;
                colSum[j] += dec;
                qDebug()<<" value="<<dec;
                //         total += dec;
            }// j
            if(xVector[i]==0){// сумма строки=0
                str = tr("<font color=\"red\">Sum=0"
                         " for row # %1</font>").arg(i+toprow+1);
                testInput->setText(str);
                return false;
            }
        }// i
        for(int j=0; j<cols; j++){// по столбцам
            if(colSum[j]==0){
                str = tr("<font color=\"red\">Sum=0 for"
                         " column # %1</font>").arg(j+leftcol+1);
                testInput->setText(str);
                return false;
            }
            // проверка названия факторов
            int ir = -1+toprow;
            if(ir<0){
                str = tr("<font color=\"red\">Factors has not names</font>");
                testInput->setText(str);
                return false;
            }
            QTableWidgetItem *item =
                    pSheet->item(-1+toprow, j+leftcol);
            if(item==0){
                str = tr("<font color=\"red\">Factor name is empty</font>");
                testInput->setText(str);
                return false;
            }else{
                scell.factNames.append(item->text());
            }
        }// конец цикла по столбцам
        numCol = cols;
    }else{// вертикальная таблица ==========================
        for(int i=0; i<rows; i++){// rows>2
            xVector[i]=0;// сумма строки
            for(int j=0; j<cols; j++){// по столбцам cols==2
                if(i==0){
                    colSum[j]=0;
                    // проверка названия выборок
                        int in = toprow-1;
                        if(in<0){
                            str = tr("<font color=\"red\">Samples has not names</font>");
                            testInput->setText(str);
                            return false;
                        }
                        QTableWidgetItem *item = pSheet->item(in, j+leftcol);
                        if(item==0){
                            str = tr("<font color=\"red\">Samples name is empty</font>");
                            testInput->setText(str);
                            return false;
                        }else{
                            scell.sampNames.append(item->text());
                        }
                    //////////////////
                }
                QTableWidgetItem *item =
                        pSheet->item(i+toprow, j+leftcol);
                if(item==0){// пустая ячейка
                    str = tr("<font color=\"red\">Empty cell</font>");
                    testInput->setText(str);
                    return false;
                }
                QString val = item->text();
                bool ok;
                int dec = val.toInt(&ok, 10);
                if(!ok || dec<0){
                    str = tr("<font color=\"red\">Wrong number</font>");
                    testInput->setText(str);
                    return false;
                }
                if(j==0){
                    R1[i] = dec;
                }else{
                    R2[i] = dec;
                }
                xVector[i] += dec;  // сумма строки
                colSum[j] += dec;   // сумма столбца
                qDebug()<<" value="<<dec;
                //         total += dec;
            }// j
            if(xVector[i]==0){// сумма строки=0
                str = tr("<font color=\"red\">Sum=0"
                         " for row # %1</font>").arg(i+toprow+1);
                testInput->setText(str);
                return false;
            }
            // проверка названия факторов
            int ir = -1+leftcol;// номер столбца названий факторов
            if(ir<0){
                str = tr("<font color=\"red\">Factors has not names</font>");
                testInput->setText(str);
                return false;
            }
            QTableWidgetItem *item =
                    pSheet->item(i+toprow, ir);
            if(item==0){
                str = tr("<font color=\"red\">Factor name is empty</font>");
                testInput->setText(str);
                return false;
            }else{
                scell.factNames.append(item->text());
            }
        }// конец цикла по строкам
        // проверка суммы столбцов
        for(int j=0; j<cols; j++){// по столбцам
            if(colSum[j]==0){
                str = tr("<font color=\"red\">Sum=0 for"
                         " column # %1</font>").arg(j+leftcol+1);
                testInput->setText(str);
                return false;
            }
        }// конец цикла по столбцам
        numCol = cols;
    }
    str = tr("<font color=\"green\"> All is good</font>");
    testInput->setText(str);
    return true;
}
//____________________________________________
// скрыть/показать специфические элементы управления
// и показать окно
void SelDialog::showSpec(){
    sbl->setHidden(true);
    sbw->setHidden(true);
    chk2x2->setHidden(true);

   switch(numTest){
   case Fisher:
      iNum = 0;
//      chk2x2->setHidden(true);
      sbw->setHidden(false);
      sbl->setHidden(false);
      spf->setValue(1);
      spf->setValue(0);
//      spf->setSpecialValueText(tr("Maximum"));
      break;
   case Chi2:
//      sbl->setHidden(true);
//      sbw->setHidden(true);
      chk2x2->setHidden(false);
      chk2x2->setChecked(false);
      break;
   case CLUSTER:
//      sbl->setHidden(true);
//      sbw->setHidden(true);
      break;
   case HARDYW:
//      sbl->setHidden(true);
//      sbw->setHidden(true);
//      chk2x2->setHidden(true);
      break;
   }
   show();// показать окно
}
//_____________________________
// тест Фишера
// iNum - кол-во знаков после запятой (0 - точный)
void SelDialog::slotSpinText(int i){
   iNum = i;// кол-во знаков после запятой
   QString NumBold, // выделенные цифры
         Num;// обычные цифры
   if(i==0){
      spf->setSpecialValueText(tr("Max"));
      NumBold = "1234567890";
      Num = "";
   }else{
      for(int j=0; j<i; j++){
         NumBold += tr("%1").arg(j+1);
      }
      for(int j=i; j<9; j++){
         Num += tr("%1").arg(j+1);
      }
      Num += "0";
   }

   NumBold += "</FONT></B>";
   QString nadp;
   nadp = "P=0.<B><FONT size=+1>" + NumBold;
   nadp += Num;
   sbl->setText(nadp);
}
