﻿//==============================================
// выделить прямоугольную область ячеек в таблице
//==============================================

#ifndef SELDIALOG_H
#define SELDIALOG_H

#include <QDialog>

class QLineEdit;
class Spreadsheet;
class QLabel;
class QCheckBox;
class QSpinBox;

#define MAXFISHER 100 // максимальное кол-во строк Фишера
// название статистического теста
enum enumTest { Fisher, Chi2, CLUSTER, HARDYW, GINTER };

// параметры выделенной области ячеек
struct selcel{
   int cols;   // кол-во выделенных столбцов
   int rows;   // кол-во строк
   int leftcol;// левый столбец (от 0)
   int toprow; // верхняя строка (от 0)
   int *R1;// первая строка
   int *R2;// вторая строка
   int *rowSum;// сумма строк
   int *colSum;// сумма столбцов
   QList<QString> factNames;// имена факторов
   QList<QString> sampNames;// имена выборок
};

class SelDialog : public QDialog
{
    Q_OBJECT

public:
   SelDialog(Spreadsheet *pSp, QWidget *parent = 0);
   selcel scell;
   int cols;    // кол-во выделенных столбцов
   int rows;    // кол-во строк
   int leftcol; // левый столбец (от 0)
   int toprow;  // верхняя строка (от 0)

   int numTest; // номер теста
   int total;   // сумма всех элементов таблицы
   int *R1;     // 1-ая строка
   int *R2;     // 2-ая строка
   int *xVector;// сумма строки
   int *colSum; // сумма столбцов
   int numCol;  // кол-во столбцов, кол-во степеней свободы

   double chi2sum;  // сумма хи-квадрат
   int iNum;        // кол-во знаков после запятой (Фишер)
   QCheckBox *chk2x2;// поправка Yates для хи-квадрат
   void showSpec(); // установить специфические элементы управления

private slots:
   void slotTestRange();
   void slotSpinText(int i);

private:
   int minCol;  // минимальное кол-во столбцов (строк)
   QString str;
   QSpinBox *spf;
   QLabel   *sbl;
   QWidget  *sbw;
   QStringList textSelect;
   QLabel   *lMes;
   QStringList nameWin;
   QLineEdit *Range;
   QLabel   *testInput;   // ошибки содержимого ячеек
   QPushButton *pOk;    // копка ОК
   Spreadsheet *pSheet; // указатель на таблицу
    // функции ------------------------------
   bool testInter();    // проверка взаимодействия
   bool testInter_Cols(int j1, int j2, int i1, int i2); //

   bool testHardyW();   // проверка Нарди-Вайнберга
   bool testCluster();  // проверка кластеризации
   bool testFisher();   // проверка Фишера
   bool testChi2();     // проверка хи-квадрат
};

#endif // SELDIALOG_H
